summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRobin H. Johnson <robbat2@gentoo.org>2015-08-08 13:49:04 -0700
committerRobin H. Johnson <robbat2@gentoo.org>2015-08-08 17:38:18 -0700
commit56bd759df1d0c750a065b8c845e93d5dfa6b549d (patch)
tree3f91093cdb475e565ae857f1c5a7fd339e2d781e /eclass/mount-boot.eclass
downloadgentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.gz
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.bz2
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.zip
proj/gentoo: Initial commit
This commit represents a new era for Gentoo: Storing the gentoo-x86 tree in Git, as converted from CVS. This commit is the start of the NEW history. Any historical data is intended to be grafted onto this point. Creation process: 1. Take final CVS checkout snapshot 2. Remove ALL ChangeLog* files 3. Transform all Manifests to thin 4. Remove empty Manifests 5. Convert all stale $Header$/$Id$ CVS keywords to non-expanded Git $Id$ 5.1. Do not touch files with -kb/-ko keyword flags. Signed-off-by: Robin H. Johnson <robbat2@gentoo.org> X-Thanks: Alec Warner <antarus@gentoo.org> - did the GSoC 2006 migration tests X-Thanks: Robin H. Johnson <robbat2@gentoo.org> - infra guy, herding this project X-Thanks: Nguyen Thai Ngoc Duy <pclouds@gentoo.org> - Former Gentoo developer, wrote Git features for the migration X-Thanks: Brian Harring <ferringb@gentoo.org> - wrote much python to improve cvs2svn X-Thanks: Rich Freeman <rich0@gentoo.org> - validation scripts X-Thanks: Patrick Lauer <patrick@gentoo.org> - Gentoo dev, running new 2014 work in migration X-Thanks: Michał Górny <mgorny@gentoo.org> - scripts, QA, nagging X-Thanks: All of other Gentoo developers - many ideas and lots of paint on the bikeshed
Diffstat (limited to 'eclass/mount-boot.eclass')
-rw-r--r--eclass/mount-boot.eclass157
1 files changed, 157 insertions, 0 deletions
diff --git a/eclass/mount-boot.eclass b/eclass/mount-boot.eclass
new file mode 100644
index 000000000000..e8bd9f63bef6
--- /dev/null
+++ b/eclass/mount-boot.eclass
@@ -0,0 +1,157 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# @ECLASS: mount-boot.eclass
+# @MAINTAINER:
+# base-system@gentoo.org
+# @BLURB: functions for packages that install files into /boot
+# @DESCRIPTION:
+# This eclass is really only useful for bootloaders.
+#
+# If the live system has a separate /boot partition configured, then this
+# function tries to ensure that it's mounted in rw mode, exiting with an
+# error if it can't. It does nothing if /boot isn't a separate partition.
+
+EXPORT_FUNCTIONS pkg_pretend pkg_preinst pkg_postinst pkg_prerm pkg_postrm
+
+# @FUNCTION: mount-boot_disabled
+# @INTERNAL
+# @DESCRIPTION:
+# Detect whether the current environment/build settings are such that we do not
+# want to mess with any mounts.
+mount-boot_is_disabled() {
+ # Since this eclass only deals with /boot, skip things when ROOT is active.
+ if [[ "${ROOT:-/}" != "/" ]] ; then
+ return 0
+ fi
+
+ # If we're only building a package, then there's no need to check things.
+ if [[ "${MERGE_TYPE}" == "buildonly" ]] ; then
+ return 0
+ fi
+
+ # The user wants us to leave things be.
+ if [[ -n ${DONT_MOUNT_BOOT} ]] ; then
+ return 0
+ fi
+
+ # OK, we want to handle things ourselves.
+ return 1
+}
+
+# @FUNCTION: mount-boot_check_status
+# @INTERNAL
+# @DESCRIPTION:
+# Figure out what kind of work we need to do in order to have /boot be sane.
+# Return values are:
+# 0 - Do nothing at all!
+# 1 - It's mounted, but is currently ro, so need to remount rw.
+# 2 - It's not mounted, so need to mount it rw.
+mount-boot_check_status() {
+ # Get out fast if possible.
+ mount-boot_is_disabled && return 0
+
+ # note that /dev/BOOT is in the Gentoo default /etc/fstab file
+ local fstabstate=$(awk '!/^#|^[[:blank:]]+#|^\/dev\/BOOT/ {print $2}' /etc/fstab | egrep "^/boot$" )
+ local procstate=$(awk '$2 ~ /^\/boot$/ {print $2}' /proc/mounts)
+ local proc_ro=$(awk '{ print $2 " ," $4 "," }' /proc/mounts | sed -n '/\/boot .*,ro,/p')
+
+ if [ -n "${fstabstate}" ] && [ -n "${procstate}" ] ; then
+ if [ -n "${proc_ro}" ] ; then
+ echo
+ einfo "Your boot partition, detected as being mounted at /boot, is read-only."
+ einfo "It will be remounted in read-write mode temporarily."
+ return 1
+ else
+ echo
+ einfo "Your boot partition was detected as being mounted at /boot."
+ einfo "Files will be installed there for ${PN} to function correctly."
+ return 0
+ fi
+ elif [ -n "${fstabstate}" ] && [ -z "${procstate}" ] ; then
+ echo
+ einfo "Your boot partition was not mounted at /boot, so it will be automounted for you."
+ einfo "Files will be installed there for ${PN} to function correctly."
+ return 2
+ else
+ echo
+ einfo "Assuming you do not have a separate /boot partition."
+ return 0
+ fi
+}
+
+mount-boot_pkg_pretend() {
+ # Get out fast if possible.
+ mount-boot_is_disabled && return 0
+
+ elog "To avoid automounting and auto(un)installing with /boot,"
+ elog "just export the DONT_MOUNT_BOOT variable."
+ mount-boot_check_status
+}
+
+mount-boot_mount_boot_partition() {
+ mount-boot_check_status
+ case $? in
+ 0) # Nothing to do.
+ ;;
+ 1) # Remount it rw.
+ mount -o remount,rw /boot
+ if [ $? -ne 0 ] ; then
+ echo
+ eerror "Unable to remount in rw mode. Please do it manually!"
+ die "Can't remount in rw mode. Please do it manually!"
+ fi
+ touch /boot/.e.remount
+ ;;
+ 2) # Mount it rw.
+ mount /boot -o rw
+ if [ $? -ne 0 ] ; then
+ echo
+ eerror "Cannot automatically mount your /boot partition."
+ eerror "Your boot partition has to be mounted rw before the installation"
+ eerror "can continue. ${PN} needs to install important files there."
+ die "Please mount your /boot partition manually!"
+ fi
+ touch /boot/.e.mount
+ ;;
+ esac
+}
+
+mount-boot_pkg_preinst() {
+ # Handle older EAPIs.
+ case ${EAPI:-0} in
+ [0-3]) mount-boot_pkg_pretend ;;
+ esac
+
+ mount-boot_mount_boot_partition
+}
+
+mount-boot_pkg_prerm() {
+ touch "${ROOT}"/boot/.keep 2>/dev/null
+ mount-boot_mount_boot_partition
+ touch "${ROOT}"/boot/.keep 2>/dev/null
+}
+
+mount-boot_umount_boot_partition() {
+ # Get out fast if possible.
+ mount-boot_is_disabled && return 0
+
+ if [ -e /boot/.e.remount ] ; then
+ einfo "Automatically remounting /boot as ro as it was previously."
+ rm -f /boot/.e.remount
+ mount -o remount,ro /boot
+ elif [ -e /boot/.e.mount ] ; then
+ einfo "Automatically unmounting /boot as it was previously."
+ rm -f /boot/.e.mount
+ umount /boot
+ fi
+}
+
+mount-boot_pkg_postinst() {
+ mount-boot_umount_boot_partition
+}
+
+mount-boot_pkg_postrm() {
+ mount-boot_umount_boot_partition
+}